Attribute VB_Name = "Module1"
Option Explicit

  Public strCharText(255) As String
  
  Public CharData(255, 31) As Byte
  Public CharUsed(255) As Boolean
  Public CharWidth As Byte
  Public CharHeight As Byte
  Public BytesPerChar As Byte
  
  Public TempDir As String
  Public Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
  Public Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
  Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

  Public PickerLeft As Single
  Public PickerTop As Single
  Public PickerPos As Boolean
  
  Public HelpLeft As Single, HelpTop As Single, HelpPos As Boolean
Public Function Hex2(Number As Variant) As String

  On Error GoTo ErrHandler
  
  'convert to string
  Hex2 = Hex(Number)
  
  'if only one character
  If Len(Hex2) = 1 Then
    Hex2 = "0" & Hex2
  End If

Exit Function

ErrHandler:
  Debug.Assert False
  'return the error?
  Err.Raise Err.Number, Err.Source, Err.Description
End Function

Public Function SaveFontFile(ByVal FontFileName As String) As Long

  Dim strTempFile As String
  Dim intFile As Integer
  Dim i As Long, j As Long
  
  On Error GoTo ErrHandler
  
  'get a temp file
  strTempFile = TempFileName()
  
  If Len(strTempFile) = 0 Then
    Exit Function
  End If
  
  intFile = FreeFile()
  Open strTempFile For Binary As intFile
    
  Put intFile, 1, CharWidth
  Put intFile, , CharHeight
  Put intFile, , BytesPerChar
  
  For i = 0 To 255
    If CharUsed(i) Then
      'if at least one pixel is set
      For j = 0 To BytesPerChar - 1
        If CharData(i, j) <> 0 Then
          'exit for
          Exit For
        End If
      Next j
      
      'if NOT exited normally,
      '(then we know at least one pixel is set)
      If j <> BytesPerChar Then
        Put intFile, , CByte(i)
        
        For j = 0 To BytesPerChar - 1
          Put intFile, , CharData(i, j)
        Next j
      End If
    End If
  Next i
  
  'add end of file marker
  Put intFile, , CByte(&HFF)
  Close intFile
  
  'delete old file, if exists
  On Error Resume Next
  Kill FontFileName
  
  'copy file
  FileCopy strTempFile, FontFileName
  
  'delete temp file
  Kill strTempFile
  
  'return success
  SaveFontFile = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Function TempFileName() As String
  Dim sTmpName As String * 576
  Dim rtn As Long

  On Error GoTo ErrHandler
  
  'get temp file name with this prefix
  rtn = GetTempFileName(TempDir, "NBF", 0, sTmpName)
  'if successful,
  If rtn <> 0 Then
    TempFileName = Left$(sTmpName, InStr(sTmpName, vbNullChar) - 1)
    'verify a filename was generated
    If Len(TempFileName) > 0 Then
      Exit Function
    End If
  End If

ErrHandler:
  Debug.Assert False
  
End Function

Public Function LoadFont(ByVal FontFileName As String) As Long

  Dim intFile As Integer
  Dim bytChar As Byte
  Dim i As Long
  
  'open the file
  On Error Resume Next
  
  intFile = FreeFile()
  Open FontFileName For Binary As intFile
  If Err.Number <> 0 Then
    Exit Function
  End If
  
  On Error GoTo ErrHandler
  
  'read width
  Get intFile, 1, CharWidth
  'read height
  Get intFile, , CharHeight
  'read bytes per char
  Get intFile, , BytesPerChar
  
  'validate:
  Select Case CharWidth
  Case 4
    If CharHeight <> 8 Or BytesPerChar <> 8 Then
      Close intFile
      Exit Function
    End If
  Case 8
    If CharHeight <> 8 Or BytesPerChar <> 8 Then
      Close intFile
      Exit Function
    End If
  Case 16
    If CharHeight <> 16 Or BytesPerChar <> 32 Then
      Close intFile
      Exit Function
    End If
  End Select
  
  'read in data, one char at a time
  Do Until EOF(intFile)
    'get char
    Get intFile, , bytChar
    If EOF(intFile) Then Exit Do
    
    For i = 1 To BytesPerChar
      Get intFile, , CharData(bytChar, i - 1)
      If EOF(intFile) Then Exit Do
    Next i
    
    If Not EOF(intFile) Then
      CharUsed(bytChar) = True
    End If
  Loop
  
  Close intFile
  
  'update char select form
  frmCharPicker.DrawCharsOnGrid
  
  'return success
  LoadFont = True
Exit Function

ErrHandler:
  Debug.Assert False
  Err.Clear
  Close intFile
End Function


Public Function JustFileName(strFullPathName As String) As String
  'will extract just the file name by removing the path info
  Dim strSplitName() As String
  
  On Error Resume Next
  
  strSplitName() = Split(strFullPathName, "\")
  If UBound(strSplitName) <= 0 Then
    JustFileName = strFullPathName
  Else
    JustFileName = strSplitName(UBound(strSplitName()))
  End If
  
End Function

